/****************************************************************
 **
 **  AIRTRAF:
 **     a wireless (802.11) traffic/performance analyzer
 **
 **  db_utils.h
 **
 ****************************************************************
 **
 **   Copyright (c) 2001 all rights reserved.
 **
 **   Author: Peter K. Lee <pkl@duke.edu>
 **
 ***************************************************************/

#ifndef __db_utils_H__
#define __db_utils_H__

#include <mysql.h>

#define QUERY_ERR    -1
#define QUERY_OK      1
#define RESULT_ERR   -1
#define RESULT_NONE   0
#define RESULT_OK     1

MYSQL * db_connect(char *host_name, char *user_name, char *password, char *db_name,
		   unsigned int port_num, char *socket_name, unsigned int flags);

void    db_disconnect(MYSQL *);

int     db_query(MYSQL *conn, char *query);

unsigned long db_get_result(MYSQL *conn, void **);

int     db_get_row(MYSQL_RES *res_set, void **);

int     db_num_rows(MYSQL *conn);

void    print_error(MYSQL *, char *message);

#endif
