/****************************************************************
 **
 **  AIRTRAF:
 **     a wireless (802.11) traffic/performance analyzer
 **
 **  poll_include.h
 **
 ****************************************************************
 **
 **   Copyright (c) 2001 all rights reserved.
 **
 **   Author: Peter K. Lee <pkl@duke.edu>
 **
 ***************************************************************/

#ifndef __poll_include_H__
#define __poll_include_H__

/* set below to enable DEBUG & DUMP_TO_SCREEN */
#define DEBUG           ENABLED
#define DUMP_TO_SCREEN  ENABLED

/**---------------------------------------------------------------
 * AIRTRAF poll_server extern global variables
 *--------------------------------------------------------------*/

extern int stop_scanning;
extern __u8 bcast[6];
extern pthread_cond_t start_cond;
extern pthread_mutex_t start_lock;

/**----------------------------------------------------------------
 * AIRTRAF INCLUDES USED THROUGHOUT THE PROGRAM
 * ( for polling server )
 *----------------------------------------------------------------*/

#include "frame_info.h"
#include "connection.h"
#include "utility.h"
#include "db_utils.h"
#include "multi_thread.h"

#endif
