/****************************************************************
 **
 **  AIRTRAF:
 **     a wireless (802.11) traffic/performance analyzer
 **
 **  channel_scan.h
 **
 ****************************************************************
 **
 **   Copyright (c) 2001,2002 all rights reserved.
 **
 **   Author: Peter K. Lee <pkl@duke.edu>
 **
 ***************************************************************/

#ifndef __channel_scan_H__
#define __channel_scan_H__

#include "definition.h"

///////////////////////////////////////////////////////////////////
//  MAIN channel scan interface routines
///////////////////////////////////////////////////////////////////

/** initialize, reserve memory map **/
void initialize_channel_scan();

/** destroy all traces of its existance **/
void free_channel_scan();

/** clean up the filter (ap) **/
void clean_filter();

/** main entrance call to do ap discovery/analysis **/
void process_channel_scan(struct packet_info *packet);

/** returns the current snapshot of results **/
struct channel_overview *get_channel_snapshot();

/** wrapper call to issue wireless extension ioctl call **/
int select_channel(struct SETTINGS*, int channel);
  
#endif
