/****************************************************************
 **
 **  AIRTRAF:
 **     a wireless (802.11) traffic/performance analyzer
 **
 **  sniff_include.h
 **
 ****************************************************************
 **
 **   Copyright (c) 2001 all rights reserved.
 **
 **   Author: Peter K. Lee <pkl@duke.edu>
 **
 ***************************************************************/

#ifndef __sniff_include_H__
#define __sniff_include_H__

/* set below to enable DEBUG & DUMP_TO_SCREEN */
#define DEBUG           DISABLED
#define DUMP_TO_SCREEN  ENABLED

/*----------------------------------------------------------------*/
/* AIRTRAF INCLUDES USED THROUGHOUT THE PROGRAM                   */
/*----------------------------------------------------------------*/

#include <ncurses.h>
#include <panel.h>

/** from libairtraf **/
#include "crc-32.h"
#include "frame_info.h"
#include "logger.h"
#include "packet_card.h"
#include "utility.h"

/** from libairgui **/
#include "attrs.h"
#include "error.h"
#include "deskman.h"
#include "menurt.h"
#include "stdwinset.h"

/** from sniffd **/
#include "channel_scan.h"
#include "detailed_analysis.h"
#include "detailed_scan.h"
#include "gui_main.h"
#include "gui_detailed_scan.h"
#include "gui_channel_scan.h"
#include "gui_gen_protocol_scan.h"
#include "gui_tcp_analysis_scan.h"
#include "mon_ids.h"
#include "server.h"
#include "runtime.h"
#include "packet_abstraction.h"
#include "p802_11b_parser.h"
#include "sniffer_engine.h"

#endif
